﻿// CInfoDlg.cpp : 実装ファイル
//

//#include "pch.h"
#include "stdafx.h"

#include "CC_Tool.h"
#include "CInfoDlg.h"
//#include "afxdialogex.h"


// CInfoDlg ダイアログ

IMPLEMENT_DYNAMIC(CInfoDlg, CDialog)

CInfoDlg::CInfoDlg(CWnd* pParent /*=nullptr*/)
	: CDialog(IDD_DIALOG_INFO, pParent)
{
#ifndef _WIN32_WCE
	EnableActiveAccessibility();
#endif

	pView = (CCC_ToolView*)pParent;
}

CInfoDlg::~CInfoDlg()
{
}

void CInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_INFO, m_ctlList);
}


BEGIN_MESSAGE_MAP(CInfoDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_INFO_SAVE, &CInfoDlg::OnBnClickedButtonInfoSave)
END_MESSAGE_MAP()


// CInfoDlg メッセージ ハンドラー


void CInfoDlg::OnBnClickedButtonInfoSave()
{
	CString path;
	FILE* stream;
	CString str;
	int		i;
	int    no;

	CString serial;

	no = pView->m_nSelect;
	serial = pView->GetSerial(no);
	serial += ".csv";
	CFileDialog dialog(FALSE,
		_T("csv"),
		_T(serial),
		OFN_FILEMUSTEXIST | OFN_SHOWHELP,
		// OPENFILENAME		OFN_CREATEPROMPT
		"csv file(*.csv)|*.csv||",
		NULL					// 
	);
	if (dialog.DoModal() == IDOK) {
		path = dialog.GetPathName();
		stream = fopen(path, "w");
		if (stream != NULL) {
			for (i = 0; i < m_ctlList.GetCount(); i++) {
				m_ctlList.GetText(i, str);
				str += "\n";
				fputs(str, stream);
			}
			fclose(stream);
		}
	}
}


BOOL CInfoDlg::OnInitDialog()
{
	int	no;
	int	i;
	CString  str, data;
	int pixel;
	
	CDialog::OnInitDialog();

	m_ctlList.ResetContent();

	no = pView->m_nSelect;
	pixel = pView->m_nPixel;
	data = pView->GetSensor(no);	str.Format("Sensor,%s", data);	m_ctlList.AddString(str);
	data = pView->GetSerial(no);	str.Format("Serial,%s", data);	m_ctlList.AddString(str);
	pView->GetComp(no, comp);
	for (i = 0; i < 6; i++) {
		str.Format("comp %d, %12.8e", i+1, comp[i]);	m_ctlList.AddString(str);
	}
	pView->GetWave(no, wave);
	pView->GetGain(no, gain);
	pView->GetDark(no, dark[0]);

	str.Format("pixel,   wave, dark(0.05s), dark(0.5s),    gain");
	m_ctlList.AddString(str);
	for (i = 0; i < pixel; i++) {
		str.Format("%5d,%7.1f, %7.1f, %7.1f, %7.3f", i+1,wave[i], dark[0][i], dark[1][i], gain[i]);
		m_ctlList.AddString(str);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
				  // 例外 : OCX プロパティ ページは必ず FALSE を返します。
}
